#include <Adafruit_NeoPixel.h>

#define LED_PIN_A    2
#define LED_PIN_B    3
#define LED_PIN_C    4
#define LED_PIN_D    5
#define LED_COUNT_L   112
#define CHASE_LENGTH  30
#define MAX_BRIGHT  127
#define SPKL_RAND   50
#define SPKL_BRT  5

int chsPos1;

Adafruit_NeoPixel strip1(LED_COUNT_L, LED_PIN_A);
Adafruit_NeoPixel strip2(LED_COUNT_L, LED_PIN_B);
Adafruit_NeoPixel strip3(LED_COUNT_L, LED_PIN_C);
Adafruit_NeoPixel strip4(LED_COUNT_L, LED_PIN_D);

void setup() {
  strip1.begin();
  strip2.begin();
  strip3.begin();
  strip4.begin();
  
  chsPos1=0;
}

void loop() {
  iceChase(5);
}

void iceChase(int wait) {
  int tally = CHASE_LENGTH;
  float mapBR = 0;
  int r=0,g=0,b=0;
  for(int x = LED_COUNT_L+CHASE_LENGTH-1; x >= 0; x--){
    if((x <= chsPos1) && (tally >= 1)){
      mapBR = MAX_BRIGHT / tally;
      r=g=int(mapBR/tally),b=int(MAX_BRIGHT/tally);
      tally--;
    }
    else{
      if(random(SPKL_RAND)>= SPKL_RAND-1){
        r=g=0,b=SPKL_BRT;
      }
      else{
        r=b=g=0;
      }
    }
    strip1.setPixelColor(x, r,g,b); //Sets pixel colors
    strip2.setPixelColor(x, r,g,b);
    strip3.setPixelColor(x, r,g,b);
    strip4.setPixelColor(x, r,g,b); 
  }
  if(chsPos1 >= LED_COUNT_L+CHASE_LENGTH){
    chsPos1=0;
  }
  else{
    chsPos1++;
  }
  strip1.show();                // Update strip with new contents
  strip2.show();
  strip3.show();
  strip4.show();
  delay(wait);                 // Pause for a moment
}
  
